/*
 * This template is valid both in C and in C++,
 * so you can expand it with code from both languages.
 * NOTE: it is recommended to use this even if you don't
 * understand the following code.
 */

#include <stdio.h>
#include <assert.h>
#include <vector>
#include <iostream>
#include <tuple>
#include <unordered_map>

using namespace std;

// constraints
#define MAXM 200000

// input data
int N, M, i;
int A[MAXM], B[MAXM], W[MAXM];
vector<vector<int>> mat;
vector<bool> used;
vector<tuple<int, int, int>> edges;
vector<vector<int>> adj;
vector<int> adjustment;

int dfs(int u, int p = -1) {
    used[u] = true;
    int delta = 0;
    for (int e : adj[u]) {
        int v, d, dual;
        tie(v, d, dual) = edges[e];

        if (v != p && d != 0) {
            if (used[v]) {
                get<1>(edges[e]) = 0;
                get<1>(edges[dual]) = 0;
                delta += d;
                adjustment[v] -= d;
            } else {
                int r = dfs(v, u);
                get<1>(edges[e]) -= r;
                get<1>(edges[dual]) += r;
                delta += r;
            }
        }
    }
    return delta + adjustment[u];
}



int main() {
//  uncomment the following lines if you want to read/write from files
//  freopen("input.txt", "r", stdin);
//  freopen("output.txt", "w", stdout);

    assert(2 == scanf("%d%d", &N, &M));
    for(i=0; i<M; i++)
        assert(3 == scanf("%d%d%d", &A[i], &B[i], &W[i]));
    
    adj.resize(N);
    int p = 0;
    unordered_map<int, unordered_map<int, int>> comp;
    for (int i = 0; i < M; i++) {
        if (comp[A[i]].count(B[i])) {
            int e, dual;
            e = comp[A[i]][B[i]];
            dual = comp[B[i]][A[i]];
            get<1>(edges[e]) += W[i];
            get<1>(edges[dual]) -= W[i];
        } else {
            edges.emplace_back(B[i], W[i], p+1);
            edges.emplace_back(A[i], -W[i], p);
            adj[A[i]].push_back(p);
            adj[B[i]].push_back(p+1);
            comp[A[i]][B[i]] = p;
            comp[B[i]][A[i]] = p+1;
            p += 2;
        }
    }
        

    used.assign(N, false);
    adjustment.assign(N, 0);
    for (int i = 0; i < N; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }

    int R = 0;
    for (int i = 0; i < edges.size(); i++) {
        if (get<1>(edges[i]) != 0) {
            R++;
        }
    }

    R /= 2;
    printf("%d\n", R);
    for (int e = 0; e < edges.size(); e++) {
        int d = get<1>(edges[e]);
        if (d != 0) {
            int b = get<0>(edges[e]);
            int dual = get<2>(edges[e]);
            int a = get<0>(edges[dual]);
            if (d > 0) {
                printf("%d %d %d\n", b, a, d);
            } else {
                printf("%d %d %d\n", a, b, -d);
            }

            get<1>(edges[e]) = get<1>(edges[dual]) = 0;
        }
    }

    return 0;
}
