/*
 * Alice Cortinovis
 * 
 * MST con algoritmo di Kruskal
 *
 * Adapted by William
 */

#include <iostream>
#include <algorithm>
#include <utility>
#include <vector>
#include <set>
#include <fstream>
#include <limits>
#include <stdio.h>

#define MAXN 100001
#define MAXM 100001

using namespace std;

struct archi{
    int a, b;
    long long w;
};

vector< pair<int, long long int> > G[MAXN];
archi ARCHI[MAXM];
long long sol;
vector<pair<int, int> > archi_sol;
int N, M;
int p[MAXN];

bool comp(archi x, archi y) {
    if (x.w != y.w) return (x.w > y.w);
    if (x.a != y.a) return (x.a < y.a);
    return (x.b < y.b);
}

int FIND(int x) {
    if (x == p[x]) return x;
    else return p[x] = FIND(p[x]);
}

void UNION(int x, int y) {
    int px = FIND(x);
    int py = FIND(y);
    if (px == py) return;
    p[px] = py;
}

int mst(int N, int M, int A[], int B[], int R[]) {
    ::N = N;
    ::M = M;
    for (int i=0; i<M; i++) {
        ARCHI[i].a = A[i];
        ARCHI[i].b = B[i];
        ARCHI[i].w = R[i];
        G[ARCHI[i].a].push_back(make_pair(ARCHI[i].b, ARCHI[i].w));
        G[ARCHI[i].b].push_back(make_pair(ARCHI[i].a, ARCHI[i].w));
    }
    sort(ARCHI, ARCHI+M, comp);
    for (int i=0; i<N; i++) p[i] = i;
    sol = numeric_limits<int>::max();
    for (int i=0; i<M; i++) {
        if (FIND(ARCHI[i].a) != FIND(ARCHI[i].b)) {
            UNION(ARCHI[i].a, ARCHI[i].b);
            sol = min(sol, ARCHI[i].w);
            archi_sol.push_back(make_pair(ARCHI[i].a, ARCHI[i].b));
        }
    }
    
    return sol;
}

int main() {
	int N, M;
        scanf(" %d %d", &N, &M);
        int *A = new int[M];
        int *B = new int[M];
        int *R = new int[M];
        for (int i = 0; i < M; i++) {
                scanf(" %d %d %d", &A[i], &B[i], &R[i]);
        }

        int result = mst(N, M, A, B, R);

        printf("%d\n", result);
}
