#!/usr/bin/env python3
# binary search on the solution, doing visits to check


# input data
N, M = map(int, input().strip().split())
A, B, R = [0] * M, [0] * M, [0] * M
for i in range(M):
    A[i], B[i], R[i] = map(int, input().strip().split())


# build the adjacency list
adj  = [[] for _ in range(N)]
for i in range(M):
    adj[A[i]].append((B[i],R[i]))
    adj[B[i]].append((A[i],R[i]))


# check if graph is connected with given rain
stack = [0 for _ in range(2*M)]
def connected(rain):
    visited = [False for _ in range(N)]
    stack[0] = 0
    size = 1
    while size > 0:
        size -= 1
        v = stack[size]
        if visited[v]:
            continue
        visited[v] = True
        for w,r in adj[v]:
            if r >= rain:
                stack[size] = w
                size += 1
    return all(visited)


# binary searches for the maximum amount of rain
def bsearch(a, b):
    if a == b:
        return a
    c = (a+b+1)//2
    if connected(c):
        return bsearch(c, b)
    return bsearch(a, c-1)

print(bsearch(min(R), max(R)))  # print the result
